#!/usr/bin/perl

require "./config.pm";
require "./siteup.pm";
print &TopOfPage();
print &JavaScripts_ls();

if ($P{'act'} eq 'checkver')
{
	print &Operation("Check for new version of the indexsoft Site-UP");
	print qq{<p><iframe src="http://www.indexsoft.com/checkver.px?program=siteup&ver=$SiteUpVer&r=$rand" width="100%" height="60" marginwidth="0" marginheight="0" scrolling="no" frameborder="0">
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript" src="http://www.indexsoft.com/checkver.px?program=siteup&ver=$SiteUpVer&r=$rand&method=javascript"></SCRIPT>
	</iframe></p>};
}
if (($P{'act'} eq 'rateus'))
{
	print &Header(qq{Rate indexsoft Site-UP});
	print qq{<p><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td>
		<form action="http://www.hotscripts.com/cgi-bin/rate.cgi" method="POST" target="_new">at HotScripts.com<br><input type="hidden" name="ID" value="18258"><select name="rate" size="1" style="width: 250px;"><option selected>Select</option><option value="5">Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select><input type="submit" value="Go!"></form>
	</td><td>
		<form action="http://www.scriptsearch.com/cgi-bin/rateit.cgi" method="post" target="_new">at ScriptSearch.com<br><input type="hidden" name="ID" value="6496"><select name="rate" size="1" style="width: 250px;"><option value="--">- Select -</option><option value="5">Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select><input type="submit" value="Go!"></form>
	</td></tr></table></p>};
}
if ($P{'act'} eq 'ftpfiles' and $P{'file'} and $P{'ftphost'})
{
	print &Operation("Put selected files and directiries from $P{'dir'} to FTP host $P{'ftphost'}");
	&FtpFiles($P{'ftphost'}, $P{'ftpport'}, $P{'ftplogin'}, $P{'ftppassword'}, $P{'ftpdir'}, split(/\0/, $P{'file'}));
}
if ($P{'act'} eq 'packfiles' and $P{'file'} and $P{'archivename'})
{
	print &Operation("Pack selected files from $P{'dir'} to archive with name $P{'menudir'}$DIRSEPARATOR$P{'archivename'}");
	&PackFiles($P{'dir'}, "$P{'menudir'}$DIRSEPARATOR$P{'archivename'}", split(/\0/, $P{'file'}));
	print &ReloadMenu();
}
if ($P{'act'} eq 'emailfiles' and $P{'file'})
{
	print &Operation("Email selected files from $P{'dir'}");
	&EmailFiles($P{'fromemail'}, $P{'toemail'}, $P{'subject'}, $P{'body'}, split(/\0/, $P{'file'}));
}
if ($P{'act'} eq 'newtemplate' and $P{'file'})
{
	print &Operation("Save file $P{'file'} as new template");
	&CopyFile("$P{'dir'}$DIRSEPARATOR$P{'file'}", ".$DIRSEPARATOR".'templates'."$DIRSEPARATOR$P{'file'}");
}
if ($P{'act'} eq 'savefile' and $P{'file'})
{
	print &Operation("Save file $P{'file'} at $P{'menudir'}");
	open(FILE, ">$P{'menudir'}$DIRSEPARATOR$P{'file'}") || print &HoldError("can not write to file $P{'menudir'}$DIRSEPARATOR$P{'file'}");
	binmode('FILE'); print FILE $P{'filecontent_top'}; print FILE $P{'filecontent'}; print FILE $P{'filecontent_bot'}; close FILE;
	print &ReloadMenu();
}
if ($P{'act'} eq 'createnew')
{
	if ($P{'file'}) { foreach $file(split(/\0/, $P{'file'})) { if ($file) { print &Operation("Create file $file at $CURDIR based on template $P{'template'}"); &CopyFile(".$DIRSEPARATOR".'templates'."$DIRSEPARATOR$P{'template'}", "$CURDIR$DIRSEPARATOR$file") } } }
	if ($P{'dirname'}) { foreach $dir(split(/\0/, $P{'dirname'})) { if ($dir) { print &Operation("Create directory $dir at $CURDIR"); mkdir ("$CURDIR$DIRSEPARATOR$dir", oct($CHMODDIRS)) || print &HoldError("can not create directory $CURDIR$DIRSEPARATOR$dir") } } }
	foreach $key(keys(%P))
	{
		if ($key =~ /uploadfile(\d+)/ && $P{$key}) { my $fid = $1; print &Operation(qq{Upload file $P{"uploadfile$fid"} at $CURDIR}); &UploadFile($CURDIR, $P{"uploadfile$fid"}, "uploadfile$fid"); }
	}
	print &ReloadMenu();
}
if ($P{'act'} eq 'copyfiles' and $P{'file'})
{
	print &Operation("Copy selected files and directories from $P{'dir'} to $P{'menudir'}");
	foreach $file(split(/\0/, $P{'file'}))
	{
		$P{$file} = $file if !$P{$file};
		if (-d "$P{'dir'}$DIRSEPARATOR$file") { &CopyDir("$P{'dir'}$DIRSEPARATOR$file", "$P{'menudir'}$DIRSEPARATOR$P{$file}") }
		else { &CopyFile("$P{'dir'}$DIRSEPARATOR$file", "$P{'menudir'}$DIRSEPARATOR$P{$file}") }
	}
	print &ReloadMenu();
}
if ($P{'act'} eq 'deletefiles' and $P{'file'})
{
	print &Operation("Remove selected files and directories from $P{'dir'}");
	foreach $file(split(/\0/, $P{'file'}))
	{
		if (-d "$P{'dir'}$DIRSEPARATOR$file") { &RemoveDir("$P{'dir'}$DIRSEPARATOR$file") }
		else { unlink ("$P{'dir'}$DIRSEPARATOR$file") || print &HoldError("can not remove file $P{'dir'}$DIRSEPARATOR$file") }
	}
	print &ReloadMenu($CURDIRESCAPED);
}
if ($P{'act'} =~ 'chmodfiles' and $P{'file'})
{
	print &Operation("Chmod selected files and directories at $P{'dir'}");
	foreach $file(split(/\0/, $P{'file'})) {	(-d "$P{'dir'}$DIRSEPARATOR$file") ? ($chmodit = $P{'chmoddirs'}) : ($chmodit = $P{'chmodfiles'}); chmod (oct($chmodit), "$P{'dir'}$DIRSEPARATOR$file") || print &HoldError("can not chmod file $P{'dir'}$DIRSEPARATOR$file") }
}
if ($P{'act'} =~ 'renamefiles'  and $P{'file'})
{
	print &Operation("Remove selected files and directories from $P{'dir'} to $P{'menudir'}");
	foreach $file(split(/\0/, $P{'file'})) { $P{$file} = $file if !$P{$file}; rename ("$P{'dir'}$DIRSEPARATOR$file", "$P{'menudir'}$DIRSEPARATOR$P{$file}") || print &HoldError("can not rename $P{'dir'}$DIRSEPARATOR$file to $P{'menudir'}$DIRSEPARATOR$P{$file}") }
	print &ReloadMenu();
}
if ($P{'act'} eq 'cd')
{
	print &ReloadMenu($CURDIRESCAPED);
}

($dirdate) = &FileInfo($CURDIR); $qty = 0; $filessize = 0;
opendir (DIR, $CURDIR);
while ($file = readdir(DIR)) { (-d "$CURDIR$DIRSEPARATOR$file") ? do{push (@dirs, "$file") if ($file ne '.' and $file ne '..')} : push (@files, $file) }
@dirs = sort @dirs; @files = sort @files;
$i = 6;
$bgcolor = '#F9F9F9';
foreach $file(@dirs, @files)
{
	($filedate, $filesize, $fileurl) = &FileInfo("$CURDIR$DIRSEPARATOR$file");
	if (-d "$CURDIR$DIRSEPARATOR$file")
	{ $filesize = 'DIR'; $filename = qq{[<b><a href="ls.cgi?act=cd&dir=$CURDIR$DIRSEPARATOR$file" title="change directory">$file</a></b>]}; }
	else
	{
		if (grep($file =~ /\.$_$/i , split(/\,/, "$TEXTFILES,$HTMLFILES"))) { $filename = qq{<a href="edit.cgi?dir=$CURDIR&file=$file" title="click to edit file">$file</a>} }
		else { $filename = $file; }
	}
	($bgcolor eq '#F9F9F9')?($bgcolor = '#FFFFFF'):($bgcolor = '#F9F9F9');
	$files .= qq{<tr bgcolor="$bgcolor" onmouseover="this.bgColor='#E8E8E8';" onmouseout="this.bgColor='$bgcolor';">
		<td><input type="checkbox" name="file" value="$file" title="select for action\nor double click to rename file to file with $BAKEXT extension" ondblclick="self.location='ls.cgi?menudir=$CURDIRESCAPED&dir=$CURDIRESCAPED&act=renamefiles&file=$file&$file=$file$BAKEXT'" onclick="filelistform.elements[$i].disabled = !filelistform.elements[$i].disabled; if (!filelistform.elements[$i].disabled) { filelistform.elements[$i].focus() }"></td>
		<td title="double click to open \n$fileurl" ondblclick="window.open('$fileurl','preview')">$filename</td>
		<td><input type="text" size="20" name="$file" class="linput" title="double click to insert file name" disabled ondblclick="filelistform.elements[$i].value = filelistform.elements[$i-1].value + '$BAKEXT'"></td>
		<td nowrap>$filedate</td>
		<td>$filesize</td>
	</tr>};
	$filessize += $filesize if $filesize ne 'DIR';
	$i += 2;
	++$qty;
}
closedir(DIR);
print &Header(qq{Selected directory $CURDIR | <a href="#" onclick="Synchronize(top.frames['menu'].curdir, false); return false;" title="Click to synchronize current directory with directory selected in menu">synchronize</a>});
print qq{<form action="ls.cgi" method="post" name="filelistform" onsubmit="SubmitForm(document.filelistform.menudir)">
<input type="hidden" name="dir" value="$CURDIR">
<input type="hidden" name="menudir" value="$CURDIR">
<p><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td>}
.(($DOCUMENT_ROOT ne $CURDIR)
?(qq{[ <a href="ls.cgi?act=cd&dir=$UPDIR">go up</a> ]})
:('&nbsp;'))
.qq{</td><td align="right">select by mask: <input type="text" name="mask" value="$P{'mask'}" class="linput" size="30" accesskey="*" title="Alt+*"> <input type="button" value="select" class="linput" onclick="SelectByMask(document.filelistform.mask.value)" accesskey="/" title="Alt+\/"></td></tr></table></p>}
.(($files)
?(qq{<table width="100%" border="0" cellspacing="0" cellpadding="0" bgcolor="#c0c0c0"><tr><td>
	<table width="100%" border="0" cellspacing="1" cellpadding="2">
	<tr bgcolor="#F9F9F9">
		<td><input title="invert selection" type="checkbox" onclick="for (var i=0;i<filelistform.elements.length;i++) { var z=filelistform.elements[i]; var zz=filelistform.elements[i+1]; if (z.name == 'file') { z.checked = !z.checked; zz.disabled = !zz.disabled; } }"></td>
		<td width="100%"><b>File name</b></td>
		<td nowrap><b>New name</b></td>
		<td nowrap><b>Last modified</b></td>
		<td><b>Size</b></td>
	</tr>	
	$files
</table></td></tr></table>
<p>$filessize bytes at $qty files and directories | directory created at $dirdate</p>
<table width="100%" border="0" cellspacing="10" cellpadding="0"><tr>
<td valign="top" width="50%">
	<input type="radio" name="act" value="deletefiles" onclick="CheckFileListForm('deletefiles')" accesskey="d" title="Alt+D"> <u>D</u>elete selected files and directories<br>
	<input type="radio" name="act" value="copyfiles" onclick="CheckFileListForm('copyfiles')" accesskey="c" title="Alt+C"> <u>C</u>opy selected files and directories<br>
	<input type="checkbox" name="act" value="renamefiles" onclick="CheckFileListForm('renamefiles')" accesskey="r" title="Alt+R"> <u>R</u>ename or move selected files and directories<br>
	<input type="checkbox" name="act" value="chmodfiles" onclick="CheckFileListForm('chmodfiles')" accesskey="h" title="Alt+H"> C<u>h</u>mod files to: <input type="text" name="chmodfiles" value="$CHMODFILES" size="3" disabled class="linput"> directories to <input type="text" name="chmoddirs" value="$CHMODDIRS" size="3" disabled class="linput">
</td>
<td valign="top" width="50%">
	<input type="radio" name="act" value="emailfiles" onclick="CheckFileListForm('emailfiles')" accesskey="m" title="Alt+M"> Send selected files by e<u>m</u>ail<br>
	<input type="radio" name="act" value="packfiles" onclick="CheckFileListForm('packfiles')" accesskey="a" title="Alt+A"> <u>A</u>rchive selected files and directories to: <input type="text" name="archivename" size="10" disabled title="type here file name of archive" class="linput"><br>
	<input type="radio" name="act" value="ftpfiles" onclick="CheckFileListForm('ftpfiles')" accesskey="u" title="Alt+U"> <u>U</u>pload selected files and directories to FTP
</td>
</tr>
<tr>
	<td><br><input type="submit" class="submit" name="submit" value="First select action" disabled accesskey="o" title="Alt+O"></td>
	<td align="right"><br><input type="Reset" class="submit" value="Reset all changes" onclick="CheckFileListForm('reset')"></td>
</tr></table>})
:(qq{</form>
	<p><blockquote>No files found</blockquote></p>
	<form action="ls.cgi" method="post">
	<input type="hidden" name="act" value="deletefiles">
	<input type="hidden" name="dir" value="$UPDIR">
	<input type="hidden" name="file" value="$FILEDIR">
	<input type="submit" class="submit" value="Delete empty directory">
}))
.'</form>';

$template = '';
opendir (DIR, ".$DIRSEPARATOR".'templates');
while ($file = readdir(DIR))
{
	$template .= qq{<option value="$file"}.(($file eq $NEWFILETEMPLATE)?(' selected'):('')).qq{>$file} if (!-d ".$DIRSEPARATOR".'templates'."$file" and $file ne '.' and $file ne '..')
}

print &Header(qq{Select an action | <a href="#" onclick="MoreFields(fields); return false;" title="only for MS Internet Explorer">more fields</a>});
print qq{<form action="ls.cgi" method="post" enctype="multipart/form-data">
<div id="fields">
<table width="100%" border="0" cellspacing="10" cellpadding="0"><tr>
<td>Create directory:<br><input type="text" name="dirname" size="17"></td>
<td>Create file:<br><input type="text" name="file" size="17"></td>
<td>Upload file:<br><input type="file" name="uploadfile1" size="17"></td>
</tr></table>
</div>
<table width="100%" border="0" cellspacing="10" cellpadding="0"><tr>
<td width="1"><input type="submit" value="    submit     " class="submit"></td>
<td>Use this template to create new files: <select name="template">$template</select></td>
</tr></table>
<input type="hidden" name="dir" value="$CURDIR">
<input type="hidden" name="act" value="createnew">
</form>};

print &BottomOfPage();

