# root directory of you webserver. leave out trailing "\" or "/"
$DOCUMENT_ROOT = $ENV{'DOCUMENT_ROOT'};

# URL of $DOCUMENT_ROOT directory. leave out trailing "/"
$HTTP_HOST = "http://$ENV{'HTTP_HOST'}";

# when create new files chmod them to this value
$CHMODFILES = '0666';

# when create new directories them it to this value
$CHMODDIRS = '0777';

# text files extensions. text editor will be used for this files
$TEXTFILES = 'txt,cgi,pl,pm,inc,php,css,js';

# html files extensions. html editor will be used for this files
$HTMLFILES = 'html,htm';

# images extensions
$IMGFILES = 'gif,jpg,png,jpeg';

# add default extension after double click on new name field for files selected for rename or copy
$BAKEXT = '.bak';

# default template for creating files (see directory templates at directory where Site-UP is installed)
# you can store here your own templates for html, php, perl, javascripts or any others files
$NEWFILETEMPLATE = 'empty.html';

# command to create archive for windows
$ADDARCHIVEWIN = '"c:\program files\winrar\rar.exe" a -inul -ep1 -y "%archive_name%" "%files_list%"';

# command to create archive for *nix
$ADDARCHIVENIX = 'tar -czf "%archive_name%" "%files_list%"';

# your email address for sending emails
$EMAIL = $ENV{'SERVER_ADMIN'};

# SMTP host (or program) and port
$SMTP = 'localhost';
$SMTPPort = '25';

# Default FTP access
$FTPHOST = 'localhost';
$FTPPORT = '21';
$FTPLOGIN = 'ftp';
$FTPPASSWORD = 'ftp@mydomain.com';
$FTPDIR = '/upload';

# WYSIWYG HTMLArea editor URL. Leave out trailing "/".
# You need to change this URL if you install Site-Up at cgi-bin directory
# If you install Site-Up at cgi-bin directory just move htmlarea directory
# to the documents root directory of web server and change $HTMLAREAURL value to '/htmlarea'
$HTMLAREAURL = 'htmlarea';

1;

